# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import popuplib
import playerlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')

# * VARIABLES

_all_    = ['Kick','Ban']
_alive_  = ['Slay','Freeze','Noclip','Godmode','Jetpack','Blind','Firework','Slap','Set Health','Invisibility','Crazy Drug']
_others_ = ['Unban','Mute','Move Players','Respawn','Give Cash']

sort = [
		'Kick','Ban','Unban','Move Players','Mute','Slay',
		'Slap','Respawn','Blind','Freeze','Jetpack','Firework',
		'Noclip','Godmode','Set Health','Give Cash','Invisibility','Crazy Drug'
	   ]

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Loads ###
	for x in (_all_,_alive_,_others_):
		for item in x: es.load('sam/base/pcontrol/' + item.replace(' ','').lower())

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	for x in (_all_,_alive_,_others_):
		for item in x: es.unload('sam/base/pcontrol/' + item.replace(' ','').lower())

	### Popups ###
	func.popupDelete('pcontrol')
	func.popupDelete('getTarget')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid, send=1):
	func.popupDelete('pcontrol')
	popup = popuplib.easymenu('pcontrol', None, function)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_name')))
	for item in sort:
		lang = item.replace('%s_' % item[0],'').replace(' ','').lower()
		popup.addoption(item.replace('%s_' % item[0],''), func.lang_titles('pcontrol_%s' % lang))
	popup.submenu(10, 'mainPage')
	if send == 1: popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def function(userid, item, popup):
	if admins.checkAccess(es.getplayersteamid(userid), item):
		name = item.replace(' ','').lower()
		if not item in _others_:
			func.popupDelete('getTarget')
			popup = popuplib.easymenu('getTarget', None, gotoFunc)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s\n \n :: %s\n # %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_%s' % name),func.lang_titles('choose_player')))
			popup.submenu(10, 'pcontrol')
			if item in _all_:
				for ply in playerlib.getPlayerList('#all'): popup.addoption({'target':ply,'func':name,'alive':0}, ply.name)
				popup.send(userid)
			elif item in _alive_:
				alive = playerlib.getPlayerList('#alive')
				if len(alive) > 0:
					for ply in alive: popup.addoption({'target':ply,'func':name,'alive':1}, ply.name)
					popup.send(userid)
				else:
					func.hudhint(userid, func.lang_pcontrol('no_alive_players'))
					modulePopup(userid)
		else: sendToOthers(userid, name)
	else: modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def gotoFunc(userid, info, popup):
	if admins.checkImmunity(es.getplayersteamid(userid), info['target'].steamid):
		block = es.import_addon('sam/base/pcontrol/%s' % info['func'])
		block.moduleAction(userid, playerlib.getPlayer(info['target']))
	else: modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendToOthers(userid, name):
	block = es.import_addon('sam/base/pcontrol/%s' % name)
	block.moduleAction(userid)

# ============================================================================================================================================================= #